/*
 
  copyright (c) 2004, Michal Salaban <emes@pld-linux.org>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License, version 2 as
  published by the Free Software Foundation (see file COPYING for details).

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
*/

/* $Id: parseopt.h,v 1.1 2004/01/29 20:20:35 emes Exp $ */

/* Data types recognized by parseopt
 *  O_STRING    stands for      char *
 *  O_BOOL        ""            int
 *  O_INT         ""            int
 *  O_FLOAT       ""            double
 */
enum {
    O_STRING,
    O_BOOL,
    O_INT,
    O_DOUBLE
};

/* Option representation type */
typedef struct {
    int         selector;
    int         otype;
    char        *repr;
} optrepr;

/* Option value container type */
typedef struct {
    int         selector;
    void        *val;
} optval;

optval get_opt (
        optrepr     (*opts)[],
        int         lastopt,
        char        *arg );

void put_opt (
        optval      (*vals)[],
        int         lastopt,
        int         otype,
        void        *oval );

void *get_val (
        optval      (*vals)[],
        int         lastopt,
        int         otype );

int fetch_opt_array (
        optval      (*vals)[],
        optrepr     (*reprs)[],
        int         lastopt,
        int         argc,
        char        *(*argv)[] );

/* $Id: parseopt.h,v 1.1 2004/01/29 20:20:35 emes Exp $ */
